#Application

C
Host
R
s

Port
R
s

Root
R
s

Request
R
s

LogFile
P
s

Protocol
P
s

#CGI

C
All
R
Collection

'Return a collection of all environment variables sent to the CGI script.
'
'The possible changes done with the [array accessor](../put) are taken into account.
FormatDate
M
s
(Date)d
_get
M
s
(Key)s
_put
M

(Value)s(Key)s
Reset
M


'Reset the CGI environment variables decoding, all possible changes to them, and call the [Request.Reset](../../request/reset) method.
Encode
M
s
(Path)s
Decode
M
s
(Path)s
_init
M


Dump
M


'Send a dump of the CGI environment variables as request response.
'
'This dump is an HTML table.
Error
M

(Text)s
#Request

C
Fields
R
String[]

Cookies
R
Collection

Method
R
s

Path
P
s

Query
P
s

Files
R
Collection

Delimiter
P
s

InternetExplorer
R
i

Referer
R
s

'Return the referer of the request.
UserAgent
R
s

'Return the user agent of the request.
Language
R
s

'Return the preferred language of the request.
'
'The 'AcceptLanguage' header of the request is analyzed, and a language description suitable
'to the [System.Language](/comp/gb/system/language) property is returned.
TempDir
P
s

'Return or set the temporary directory used to store the files uploaded by the request.
'
'By default, uploaded files are stored in the '/tmp' directory. Changing it is useful if '/tmp' is not big enough.
MaxFileSize
P
l

'Return or set the maximum size of an uploaded file.
'
'By default, files bigger than 128 MB are not allowed.
'
'[[ warning
'Do check your HTTP server that usually has its own limit too.
']]
ContentType
R
s

'Return the content type of the request.
ContentLength
R
i

'Return the content lenth of the request.
Scheme
P
s

'Return or set the scheme of the request.
'
'It is normally 'http' or 'https'.
'
'[[ warning
'The value of this property is guessed by analyzing a few well-known request headers sent by the HTTP server to the CGI script.
'If it fails for you, please fill an issue on the Gambas bugtracker.
']]
Get
R
_Request_Get

Post
R
_Request_Post

Debug
P
b

_init
M


Reset
M


'Reset the request decoding
_get
M
s
(Key)s
Exist
M
b
(Field)s
_put
M

(Value)s(Key)s
#Response

C
Buffered
P
b

ContentType
P
s

Status
P
s

EndOfLine
P
i{EndOfLine}

Done
R
b

'Return if the response has been sent, i.e. if the [../end] method has been called.
Cookie
R
_Response_Cookie

'@{since 3.19}
'
'Return a virtual object used for defining the default properties of the cookie sent to the client
AddHeader
M

(Name)s(Value)s
Redirect
M

(URL)s
Begin
M

[(ContentType)s]
End
M


SetCookie
M

(Cookie)s(Value)s[(Domain)s(Path)s(Expires)d(HttpOnly)b]
RemoveCookie
M

(Cookie)s(Value)s[(Domain)s(Path)s]
Reset
M


'Reset the response contents.
'
'Use the [../cancel] method instead.
Cancel
M


'Try to cancel the response.
'
'This method will fail if the response is not buffered and has been partially sent.
GetContentTypeFrom
M
s
(Path)s
SendFile
M

(Path)s[(ContentType)s]
#Session

C
Type
P
s

'Return or set the session type.
'
'The supported types are:
'
'[[
'==
''file'
'-
'The session is serialized in a binary file.
'==
''sqlite'
'--
'The session is stored in a SQLite3 file. The [/comp/gb.db.sqlite3] component is automatically loaded if needed.
']]
Id
P
s

Timeout
P
f

Prefix
P
s

Unique
P
b

Modified
P
b

CookiePath
P
s

Keys
R
String[]

Size
R
l

'Return the session file size.
Path
R
s

'Return the session file path.
Load
M


_exit
M


Abandon
M


_get
M
v
(Key)s
Exist
M
b
(Key)s
_put
M

(Value)v(Key)s
Save
M


_MakeId
M


#URL

C
SetQuery
M
s
(URL)s(Field)s(Value)s
UnsetQuery
M
s
(URL)s(Field)s
#WebPage

CA
Buffered
p
b

Parent
r
o

Main
M


Render
m

[(Args)Collection;]
_Render
m

[(_Arg)Collection;]
__Render
m

[(_Arg)Collection;]
_RenderEnd
m


__RenderEnd
m


ToString
m
s

#_Request_Get

CA
Fields
r
String[]

_get
m
s
(Key)s
Exist
m
b
(Field)s
_Reset
m


#_Request_Post

CA
Fields
r
String[]

Files
r
Collection

Contents
r
s

Exist
m
b
(Field)s
_get
m
s
(Key)s
_Reset
m


#_Response_Cookie

CA
'@{since 3.19}
'
'This class allows to define the default properties of the cookie sent to the client
'
'See [https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Set-Cookie] for the details.
Domain
v
s

'Return or set the cookie domain.
Path
v
s

'Return or set the cookie path.
Expires
v
d

'Return or set the cookie expiration date.
HttpOnly
v
b

'Return or set if the cookie is only visible to HTTP requests (and not Javascript code).
Secure
v
b

'Return or set if the cookie is only set on HTTPS requests.
SameSite
v
s

'Return or set the "SameSite" cookie policy.
'
'It can be `"Lax"`, `"Strict"` or `"None"`, `"Lax"` being the default value.
'
'If the property is set to `"None"`, then the cookie is always sent with the "Secure" attribute.
